// Medusa is a graph viewer which allows interactive editing of networks
// (edges and nodes) and also connects to databases.
//
// Copyright (C) 2006 Sean Hooper
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or (at 
// your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
// Public License for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
package medusa;

import java.awt.*;
import javax.swing.*;

abstract class FGProgBar {
    private JFrame parent;
    private String text;
    private JWindow win;
    private boolean indeterminate = true;
    private JProgressBar prog;
   
    
    public abstract void doWork();

    
	

    public FGProgBar(JFrame parent, String text) throws IllegalArgumentException {
        this.parent = parent;
        if (this.parent == null) {
            throw new IllegalArgumentException("parent == null !");
        }

        this.text = text;
        if (this.text == null) {
            this.text = "Processing";
        }

        prog = new JProgressBar();
        //prog.setIndeterminate(indeterminate); // todo TA TILLBAKS TILL JRE1.4.1
        prog.setStringPainted(true);
        prog.setString(text);

        JPanel progPanel = new JPanel();
        progPanel.setBorder(BorderFactory.createRaisedBevelBorder());
        progPanel.add(prog);

        win = new JWindow(parent);
        win.setSize(200, 25);
        //GUIHelper.centerWindow(win); //denna method lagger applicationen mitt pa skarmen
        win.getContentPane().add(progPanel);
        win.pack();
    }

    public void setIndeterminate(boolean value) {
        indeterminate = value;
    }
    public void setProgress(int value){
	prog.setValue(value);
    }

    public void show() {
        win.setVisible(true);

        new Thread(new Runnable() {
            public void run() {
                doWork();

                win.setVisible(false);
                win.dispose();
            }
        }).start();
	}
}

//Exempel pa anvandning i en annan klass TYP

/*
FGProgBar prog = new FGProgBar(createFrame, "Laddar foretag...") {
                public void doWork() {

                        //
			//
			//DO da Shit
			//
			//

                }
            };
            prog.show();
*/
